package demo;

import javax.swing.JOptionPane;

import com.dessci.mathflow.sdk.editor.SimpleEditorFrame;
import com.dessci.mathflow.sdk.license.LicenseException;
import com.dessci.mathflow.sdk.license.LicenseSource;

import webeq3.util.EquationUtilities;

/**
 * This class implements a demo of MathFlow SDK simple editor.
 * 
 * Copyright (c) 1987-2009 by Design Science, Inc. All rights reserved.
 */
public class DemoSimpleEditor extends SimpleEditorFrame {

	// show a message box in the native application when this editor window closes 
	private native void ShowMathML();

	static {
		try {
			System.loadLibrary("MFEditorCallback");
		}
		catch (Exception e) {
			String errorString = "Can't load library: " + e;
			JOptionPane.showMessageDialog(null, errorString, "Error", JOptionPane.ERROR_MESSAGE);
		}
	}

	public DemoSimpleEditor() throws LicenseException {
//		super(null, "MFSA192-100814-VR8EM", LicenseSource.DESSCI_KEY);
		super(null, "dessci.lic", LicenseSource.FLEXLM_LIC);
		setToolbarMarkup("<tb><btn>LAYOUTPALETTE</btn><sub cols='3'><incl name='#layout'/></sub></tb>");
	}

	protected void closeEditorWindow() {
		super.closeEditorWindow();		
		ShowMathML();
	}

	public String getMathML() {
		return super.getFormattedMathML(EquationUtilities.MIXED_MARKUP, EquationUtilities.PRETTY_PRINT, 0, "", EquationUtilities.ENTITY_NAMES);
	}

	public static void main(String args[]) {
		try {
			DemoSimpleEditor d = new DemoSimpleEditor();
			d.show();
		}
		catch(Exception e) {
			System.out.println(e);
		}
	}
}