// CallbackImpl.cpp --- Copyright (c) 1987-2009 by Design Science, Inc.
// purpose : implements the callback behavior

#include "stdafx.h"

#include "jni.h"
#include "jni_md.h"

// Demo Assert mechanism defaults to standard
#define Assert _ASSERT

/*
 * Class:     demo_DemoSimpleEditor
 * Method:    ShowMessage
 * Signature: ()V
 */

extern "C" JNIEXPORT void JNICALL Java_demo_DemoSimpleEditor_ShowMathML
  (JNIEnv *env, jobject obj)
{
	// load the Java editor class
	jclass localClsRef = env->FindClass("demo/DemoSimpleEditor");
	Assert(localClsRef);

	// lookup the method id for String getFormattedMathML(int, int, int, String, int)
	jmethodID mid = env->GetMethodID(localClsRef, "getFormattedMathML", "(IIILjava/lang/String;I)Ljava/lang/String;");
	Assert(mid);

	jint markupType = 1; // Equation.MIXED_MARKUP
	jint formatLevel = 0; // Equation.PRETTY_PRINT 
	jint namespaceAttr = 0;	// false (don't use namespace)
	jint characterType = 0; // Equation.ENTITY_NAMES

	const jchar *unicodeChars = (jchar *)L"";
	jstring prefixStr = env->NewString(unicodeChars, 0);
	Assert(prefixStr);
	
	// call getFormattedMathML method on the Java editor object and return the String object
	jobject infoStr = env->CallObjectMethod(obj, mid, markupType, formatLevel, 
		    namespaceAttr, prefixStr, characterType); 

	// extract characters from the returned String object
	const jchar * retChars = env->GetStringChars((jstring)infoStr, 0);
	Assert(retChars);

	// show the MathML returned by the Java editor object
	MessageBox(NULL,(OLECHAR *)retChars,L"",MB_OK); 
}
