// JNIClient.h --- Copyright (c) 1987-2009 by Design Science, Inc.
// purpose: CJNIClient declarations

#ifndef JNICLIENT_H
#define JNICLIENT_H

#include "jni.h"
#include "jawt.h"
#include "jawt_md.h"

class CJNIClient {
public:
	CJNIClient();
	~CJNIClient();

protected:
	HRESULT InitJavaObject(const char* className);
	HRESULT RefreshJNIEnv();
	HRESULT CallVoidVoidMethod(const char *name);
	HRESULT CallVoidIntMethod(const char *name, int *retValue);
	HRESULT CallVoidStringMethod(const char *name, BSTR *retValue);
	HRESULT CallStringVoidMethod(const char *name, BSTR value);
	HRESULT CallBoolVoidMethod(const char *name, BOOL value);
	HRESULT CallVoidBoolMethod(const char *name,BOOL* value);
	HRESULT BSTRToJString(BSTR in, jstring *out);
	HRESULT JStringToBSTR(jobject in, BSTR *out);

	HWND GetHWND();

	JNIEnv * m_env;
	jobject m_Obj;
	jclass  m_Cls;
	BOOL m_Initialized;

};

#endif // JNICLIENT_H