// JavaVM.h --- Copyright (c) 1987-2009 by Design Science, Inc.
// purpose: CJavaVM declarations

#ifndef JAVAVM_H
#define JAVAVM_H

#include "jni.h"
#include "jawt.h"

// define a type-safe function pointers for calls to GetProcAddress
typedef jint (JNICALL* LPFNJVMFUNC)(JavaVM **pvm, void **penv, void *args);
typedef jboolean (JNICALL* LPFNAWTFUNC)(JNIEnv* env, JAWT* awt);

class CJavaVM {
public:
	CJavaVM() : m_pjvm(0), m_pfnGetAwt(0) { 
		version = 0x00010002; // set VM version
	}

	HRESULT InitVM(BSTR dllpath, BSTR classpath);
	JavaVM *GetJavaVMPtr();
	HRESULT GetAWT(JNIEnv * m_env, JAWT *awtReturn);
	jint version;

private:
	// NO_COPY_OR_ASSIGN
	void operator = (CJavaVM &); 
	CJavaVM(CJavaVM &);

	char m_JREpath[256];
	JavaVM *m_pjvm;
	LPFNAWTFUNC m_pfnGetAwt;
};

// make a global singleton instance available throughout the DLL
extern CJavaVM theJVM;

#endif // JAVAVM_H